#ifndef POLYMESH3H
#define POLYMESH3H

#include <coef.h>
#include <D3DX9.h>

#include <crtdbg.h>
//#include <infelem.h>

#include <map>
using namespace std;

class CMQOMaterial;
class CMQOFace;

class CPolyMesh3
{
public:
	CPolyMesh3();
	~CPolyMesh3();

	int CreatePM3( int pointnum, int facenum, float facet, D3DXVECTOR3* pointptr, CMQOFace* faceptr, 
		map<int,CMQOMaterial*>& srcmat, D3DXMATRIX multmat );
	
	int SetIndexBuf();	
	int InvIndexBuf();

	int ChkAlphaNum( map<int,CMQOMaterial*>& srcmat );
	int CalcBound();

private:
	void InitParams();
	void DestroyObjs();

	int MultVert( D3DXMATRIX multmat );
	int CreateN3PFromMQOFace( N3P* n3pptr, int* numptr );

	int CalcOrgNormal();
	int CalcNormal( D3DXVECTOR3* newn, D3DXVECTOR3* curp, D3DXVECTOR3* aftp1, D3DXVECTOR3* aftp2 );
	int Vec3Cross( D3DXVECTOR3* pOut, D3DXVECTOR3* pV1, D3DXVECTOR3* pV2 );
	int Vec3Normalize( D3DXVECTOR3* retvec, D3DXVECTOR3* srcvec );

	int SetSMFace();
	int AddSmFace( N3P* n3p1, N3P* n3p2 );
	int CalcSMNormal();

	int SetOptV( PM3DISPV* optv, int* pleng, int* matnum, map<int,CMQOMaterial*>& srcmat );


public:
/***
typedef struct tag_verface
{
	int			faceno;
	int			orgfaceno;
	int			materialno;
	D3DXVECTOR3	facenormal;
}PERFACE;

typedef struct tag_pervert
{
	int				indexno;//3p̏
	int				vno;
	int				uvnum;
	D3DXVECTOR2		uv[2];
	int				vcolflag;
	DWORD			vcol;
	D3DXVECTOR3 smnormal;

	int				createflag;
		//_쐬ȂꍇO
		//UV, VCOL, MaterialnöႢɂ쐬ꍇ͂P𑫂
		//normalɂ쐬ꍇ͂Q𑫂
}PERVERT;

typedef struct tag_n3sm
{
	int smfacenum;
	void** ppsmface;//N3Pւ̃|C^̔z
}N3SM;

typedef struct tag_n3p
{
	PERFACE*	perface;
	PERVERT*	pervert;
	N3SM*		n3sm;
}N3P;//n*3


n3pvno, materialno, uv, vcolŃ\[gn3psortB
n3psort𓪂`FbNA܂̂createflagɂP𑫂B

n3psortvnô̖@`FbNX[WÔppsmfaceɒǉB
SI
n3psortvnô*ppsmface`FbNAn߂ďoƂ܂͏oȂƂcreateflagɂQĂȂƂ
createflagɂQ𑫂B

n3smsmnormalvZB

n3psortmaterialno, faceno, indexnoŃ\[gn3pafterB

n3paftercreateflagĂOȊÔ̂PM3OPTVB

typedef struct tag_pm3optv
{
	int orgvno;
	int orgfaceno;
	D3DXVECTOR3 pos;
	int materialno;
	D3DXVECTOR3 normal;
	int				uvnum;
	D3DXVECTOR2		uv[2];
	int				vcolflag;
	DWORD		vcol;
}PM3OPTV;


***/

	int m_orgpointnum;
	int m_orgfacenum;
	int m_facenum;//Op̖ʐ

	float m_facet;
	CMQOFace* m_mqoface;//O
	D3DXVECTOR3* m_pointbuf;//O
	N3P* m_n3p;

///////
	int m_optleng;
	int m_optmatnum;
//	PM3OPTV* m_optv;
	PM3DISPV* m_dispv;
	int*	m_dispindex;
	int m_createoptflag;

	MATERIALBLOCK* m_matblock;
	MODELBOUND	m_bound;

	CHKALPHA chkalpha;
};



#endif